<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/28/2008 *
 * ===============                              Last change: 09/28/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : refback_functions.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Functions for refback extension                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Funktionen fuer Refback-Erweiterung              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
}

// Payback refback for refid and reduce it for current user
function addRefbackPoints ($userid, $ref, $points, $ref_points) {
	//* DEBUG: */ outputHtml("----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n");
	// Back ref depths
	$GLOBALS['refback_depth'][$userid][$ref] = $GLOBALS['ref_level'];

	// Init points
	$return = $points;

	// Get all ref levels
	$result_refs = SQL_QUERY("SELECT `level`, `percents` FROM `{?_MYSQL_PREFIX?}_refdepths` WHERE `level` > 0 ORDER BY `level` ASC",
		__FUNCTION__, __LINE__);

	// "Walk" through all level
	while ($content = SQL_FETCHARRAY($result_refs)) {
		// Reset ref depths
		// @TODO Try to rewrite the following unset()
		unset($GLOBALS['ref_level']);

		// "Walk" through all refids
		//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},ref={$ref},level={$content['level']},points={$points}<br />");
		foreach (getArrayFromRefbackLevel($userid, $content['level']) as $refid) {
			// Skip level zero or if both are the same
			if ($userid == $refid) continue;

			// Get refback percents
			$percents = getRefbackPercents($userid, $refid);
			//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},ref={$ref},refid={$refid},points={$points},percents={$percents}<br />");

			// Some percents given?
			if ($percents > 0) {
				//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):points={$points},perc={$content['percents']},percents={$percents},level={$content['level']}<br />");
				// Calculate points for refback
				$refback = $points * ($content['percents'] / 100) * ($percents / 100);

				// Update refback table ("refid" and "userid" must be exchanged!)
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_refs` SET `points`=`points`+%s WHERE `userid`=%s AND `refid`=%s LIMIT 1",
					array($refback, $refid, $userid), __FUNCTION__, __LINE__);
				//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):refback={$refback},userid={$userid},refid={$refid} - UPDATE! (".SQL_AFFECTEDROWS().")<br />");

				// Add points again, but only directly
				//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):refback={$refback}<br />");
				addPointsDirectly(sprintf("refback:%s", $refid), $userid, $refback);

				// Reduce points if refid is found
				if ($refid == $ref) {
					// Reduce points here!
					$return = $points * ($content['percents'] / 100) - $refback;
					//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):points={$return} - REDUCED<br />");
				} // END - if
			} // END - if
		} // END foreach
	} // END - while

	// Free result
	SQL_FREERESULT($result_refs);

	// Restore ref depth
	$GLOBALS['ref_level'] = $GLOBALS['refback_depth'][$userid][$ref];

	// Return them
	//* DEBUG: */ outputHtml("</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />");
	return $return;
}

// "Getter" for refback percents
function getRefbackPercents ($userid, $ref) {
	//* DEBUG: */ outputHtml("----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n");
	//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},ref={$ref}<br />");
	// Skip identical ids
	if ($userid == $ref) return 0;

	// Default is zero
	$percents = 0;

	// Get percents from database
	$result = SQL_QUERY_ESC("SELECT refback FROM `{?_MYSQL_PREFIX?}_user_refs` WHERE `userid`=%s AND `refid`=%s LIMIT 1",
	array($ref, $userid), __FUNCTION__, __LINE__);

	// Entry found? (Should be!)
	if (SQL_NUMROWS($result) == 1) {
		// Fetch percents
		list($percents) = SQL_FETCHROW($result);
		//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):percents={$percents}<br />");
	} else {
		// Debug log
		//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>): NO ENTRY FOUND! :-(<br />");
		logDebugMessage(__FUNCTION__, __LINE__, "userid={$userid},ref={$ref} - No entry found! :-(");
	}

	// Free result
	SQL_FREERESULT($result);

	// Return percents
	//* DEBUG: */ outputHtml("</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />");
	return $percents;
}

// "Getter" for userid array which will return only one entry
function getArrayFromRefbackLevel ($rid, $level) {
	//* DEBUG: */ outputHtml("----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n");
	//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):rid={$rid},level={$level}<br />");
	// Init userids
	$userIds = array();

	// Look for all
	$result = SQL_QUERY_ESC("SELECT
	`userid`
FROM
	`{?_MYSQL_PREFIX?}_user_refs`
WHERE
	`refid=`%s AND `level`=%s
ORDER BY
	`userid` ASC",
		array($rid,$level), __FUNCTION__, __LINE__);

	// Entries found?
	//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):numRows=".SQL_NUMROWS($result)."<br />");
	if (SQL_NUMROWS($result) > 0) {
		// Add all
		while ($content = SQL_FETCHARRAY($result)) {
			//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):rid={$rid},level={$level},userid={$content['userid']}<br />");
			$userIds[] = $content['userid'];
		} // END - while
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Return array
	//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):rid={$rid},count()=".count($userIds)."<br />");
	//* DEBUG: */ outputHtml("</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />");
	return $userIds;
}

// Update "refback table"
function updateRefbackTable ($userid) {
	//* DEBUG: */ outputHtml("----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n");
	// Make it sure referal level zero (member him-/herself) is at least selected
	if (empty($GLOBALS['refback_level'])) $GLOBALS['refback_level'] = 1;
	//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},level={$GLOBALS['refback_level']}<br />");

	// Init refid
	$GLOBALS['refback_refid'][$GLOBALS['refback_level']] = 0;
	$old = 0; $minus = 0;

	// Check for his referal
	$result_refid = SQL_QUERY_ESC("SELECT `userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `refid`=%s ORDER BY `userid` ASC",
		array(bigintval($userid)), __FUNCTION__, __LINE__);

	// When no entry was updated then we have to create it here
	//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):found=".SQL_NUMROWS($result_refid)."<br />");
	if (SQL_NUMROWS($result_refid) > 0) {
		// Load all refids
		while (list($GLOBALS['refback_refid'][$GLOBALS['refback_level']]) = SQL_FETCHROW($result_refid)) {
			// Remmber userid
			$GLOBALS['refback_userid'][$GLOBALS['refback_refid'][$GLOBALS['refback_level']]] = $userid;

			// Refid set?
			//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},ref={$GLOBALS['refback_refid'][$GLOBALS['refback_level']]}<br />");
			if (($GLOBALS['refback_refid'][$GLOBALS['refback_level']] > 0) && ($GLOBALS['refback_refid'][$GLOBALS['refback_level']] != $userid) && (isset($GLOBALS['refback_refid'][$GLOBALS['refback_level']]))) {
				// New userid?
				if ((isset($GLOBALS['refback_refid'][$GLOBALS['refback_level']-1])) && (isset($GLOBALS['refback_userid'][$GLOBALS['refback_refid'][$GLOBALS['refback_level']-1]]))) {
					// New userid!
					$old = $userid;
					$userid = $GLOBALS['refback_userid'][$GLOBALS['refback_refid'][$GLOBALS['refback_level']-1]];
					$minus = 1;
					//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},old={$old},level={$GLOBALS['refback_level']},ref={$GLOBALS['refback_refid'][$GLOBALS['refback_level']]} - NEW UID!<br />");
				} // END - if

				// Check existence
				$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_user_refs` WHERE `userid`=%s AND `level`='%s' AND `refid`=%s LIMIT 1",
					array(bigintval($userid), $GLOBALS['refback_level'], bigintval($GLOBALS['refback_refid'][$GLOBALS['refback_level']])), __FUNCTION__, __LINE__);

				// Do we have no entry?
				//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},level={$GLOBALS['refback_level']},ref={$GLOBALS['refback_refid'][$GLOBALS['refback_level']]},minus={$minus},numRows=".SQL_NUMROWS($result)." - FOUND!<br />");
				if (SQL_NUMROWS($result) == 0) {
					// Insert this level
					//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},level={$GLOBALS['refback_level']},ref={$GLOBALS['refback_refid'][$GLOBALS['refback_level']]} - ADD!<br />");
					SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_refs` (`userid`,`level`,`refid`) VALUES (%s,%s,%s)",
						array(bigintval($userid), $GLOBALS['refback_level'], bigintval($GLOBALS['refback_refid'][$GLOBALS['refback_level']])), __FUNCTION__, __LINE__);

					// Move to next referal level and count his counter one up!
					$GLOBALS['refback_level']++; updateRefbackTable($GLOBALS['refback_refid'][($GLOBALS['refback_level'] - 1)]);
				} // END - if

				// Do we have another level here?
				if ((($GLOBALS['refback_level']-$minus) > 0) && ($old > 0)) {
					// Restore old one
					$userid = $old;

					// Shall we add this as well?
					$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_user_refs` WHERE `userid`=%s AND `level`='%s' AND `refid`=%s LIMIT 1",
						array(bigintval($userid), ($GLOBALS['refback_level']-$minus), bigintval($GLOBALS['refback_refid'][$GLOBALS['refback_level']])), __FUNCTION__, __LINE__);

					// Do we have no entry?
					//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},level=".($GLOBALS['refback_level']-$minus).",ref={$GLOBALS['refback_refid'][$GLOBALS['refback_level']]},numRows=".SQL_NUMROWS($result)." - BACK!<br />");
					if (SQL_NUMROWS($result) == 0) {
						// Insert this level
						SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_refs` (`userid`,`level`,`refid`) VALUES (%s,%s,%s)",
							array(bigintval($userid), ($GLOBALS['refback_level']-$minus), bigintval($GLOBALS['refback_refid'][$GLOBALS['refback_level']])), __FUNCTION__, __LINE__);
						//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},level=".($GLOBALS['refback_level']-$minus).",ref={$GLOBALS['refback_refid'][$GLOBALS['refback_level']]} - RETURNED!<br />");
					} // END - if
				} // END - if
			} // END - if
		} // END - while

		// Free memory
		SQL_FREERESULT($result_refid);
	} // END - if

	// When he has a referal...
	if ((($GLOBALS['refback_refid'][$GLOBALS['refback_level']] == $userid) || ($GLOBALS['refback_refid'][$GLOBALS['refback_level']] == 0)) && (getExtensionVersion('cache') >= '0.1.2') && (!isset($GLOBALS['refback_cached']))) {
		// Remove cache here
		//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},ref={$GLOBALS['refback_refid'][$GLOBALS['refback_level']]} - CACHE!<br />");
		if ($GLOBALS['cache_instance']->loadCacheFile('refback')) $GLOBALS['cache_instance']->removeCacheFile();
		$GLOBALS['refback_cached'] = 1;
	} // END - if

	// "Walk" back here
	$GLOBALS['refback_level']--;
	//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},level={$GLOBALS['refback_level']} - LEVEL!<br />");

	// Fix empty refid
	if (!isset($GLOBALS['refback_refid'][$GLOBALS['refback_level']-1])) $GLOBALS['refback_refid'][$GLOBALS['refback_level']-1] = 0;
	//* DEBUG: */ outputHtml(__FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):userid={$userid},level={$GLOBALS['refback_level']},ref={$GLOBALS['refback_refid'][$GLOBALS['refback_level']-1]} - BACK!<br />");
	//* DEBUG: */ outputHtml("</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />");
}

// "Getter" for array for user refs in given level
function getArrayFromRefbackUserRefs ($userid, $level) {
	//* DEBUG: */ outputHtml("----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n");
	// Default is no refs and no nickname
	$add = '';
	$refs = array();

	// Do we have nickname extension installed?
	if (isExtensionActive('nickname')) {
		$add = ", d.nickname";
	} // END - if

	// Get refs from database
	$result = SQL_QUERY_ESC("SELECT
	r.id,
	r.refid,
	r.refback,
	r.points,
	d.status".$add."
FROM
	`{?_MYSQL_PREFIX?}_user_refs` AS r
LEFT JOIN
	`{?_MYSQL_PREFIX?}_user_data` AS d
ON
	r.refid=d.userid
WHERE
	r.userid=%s AND r.level=%s
ORDER BY
	r.refid ASC",
		array(bigintval($userid), bigintval($level)), __FUNCTION__, __LINE__);

	// Are there some entries?
	if (SQL_NUMROWS($result) > 0) {
		// Fetch all entries
		while ($row = SQL_FETCHARRAY($result)) {
			// Add row
			$refs[$row['id']] = $row;
		} // END - while
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Return result
	//* DEBUG: */ outputHtml("</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />");
	return $refs;
}

// "Getter" for refback entry
function getArrayFromUserRefbackData ($id) {
	//* DEBUG: */ outputHtml("----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n");
	// Default data is nothing
	$data = array();

	// Secure id number
	$id = bigintval($id);

	// Get entry from database
	$result = SQL_QUERY_ESC("SELECT `id`, `refid`, `refback`, `level` FROM `{?_MYSQL_PREFIX?}_user_refs` WHERE `id`=%s AND `userid`=%s LIMIT 1",
		array($id, getUserId()), __FUNCTION__, __LINE__);

	// Is there an entry?
	if (SQL_NUMROWS($result) == 1) {
		// Fetch data
		$data = SQL_FETCHARRAY($result);
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Return entry
	//* DEBUG: */ outputHtml("</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />");
	return $data;
}

// Update refback percents (but with some sanity-checks!
function updateMemberRefbackPercents ($id, $percents) {
	//* DEBUG: */ outputHtml("----------------------- <font color=\"#00aa00\">".__FUNCTION__." - ENTRY</font> ------------------------<ul><li>\n");
	// Default status is failed
	$status['message'] = getMessage('MEMBER_REFBACK_ERROR_GENERAL');

	// Do some sanity-checks
	if (!isMember()) {
		// No member!
		$status['message'] = getMessage('MEMBER_REFBACK_ERROR_NO_MEMBER');
		return $status;
	} elseif (''.$id.'' != ''.($id + 0).'') {
		// No number!
		$status['message'] = getMessage('MEMBER_REFBACK_ERROR_INVALID_ID_NUMBER');
		return $status;
	} elseif (($percents < 0) || ($percents > 100)) {
		// Percentage is not valid!
		$status['message'] = getMessage('MEMBER_REFBACK_ERROR_INVALID_PERCENTAGE');
		return $status;
	}

	// Get ref entry
	$dummy = getArrayFromUserRefbackData($id);

	// Is this valid?
	if (count($dummy) == 0) {
		// ID does not belong to user!
		$status['message'] = getMessage('MEMBER_REFBACK_ERROR_ID_MISMATCH');
		return $status;
	} // END - if

	// Revert german commata
	$percents = convertCommaToDot($percents);

	// Update entry
	SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_refs` SET `refback`='%s' WHERE `id`=%s AND `userid`=%s LIMIT 1",
		array($percents, $id, getUserId()), __FUNCTION__, __LINE__);

	// Entry updated?
	if (SQL_AFFECTEDROWS() < 1) {
		// Entry not updated!
		$status['message'] = getMessage('MEMBER_REFBACK_ERROR_NOT_UPDATED');
		return $status;
	} // END - if

	// Prepare email content
	$content = array(
		'percents' => translateComma($percents),
		'refid'    => $dummy['refid'],
		'level'    => $dummy['level']
	);

	// Load member email template
	$mail = loadEmailTemplate('member_refback', $content, getUserId());

	// Send email to user
	sendEmail($dummy['refid'], getMessage('MEMBER_REFBACK_SUBJECT'), $mail);

	// Send admin notification
	sendAdminNotification(getMessage('ADMIN_REFBACK_SUBJECT'), 'admin_refback', $content, getUserId());

	// All fine!
	$status['ok'] = true;

	// Return status array
	//* DEBUG: */ outputHtml("</li></ul>----------------------- <font color=\"#aa0000\">".__FUNCTION__." - EXIT</font> ------------------------<br />");
	return $status;
}
//
?>
